﻿using AxisGroupingDemo.Data.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AxisGroupingDemo.Data
{
    public class DataService
    {
        public static List<State> GetAQIData()
        {
            var states = new List<State>();
            var rows = Resources.AQI2017.Split(new string[] { "\r\n" }, StringSplitOptions.RemoveEmptyEntries);
            for (int i = 1; i < rows.Count(); i++)
            {
                var row = rows[i];
                var items = row.Split(',');

                var stateName = items[0];
                var countyName = items[1];
                var pm10 = Convert.ToDouble(items[2]);
                var pm2_5 = Convert.ToDouble(items[3]);

                var state = states.FirstOrDefault(s => s.Name.Equals(stateName));
                if (state == null)
                {
                    state = new State() { Name = stateName };
                    states.Add(state);
                }
                state.Counties.Add(new County
                {
                    Name = countyName,
                    PM10 = pm10,
                    PM2_5 = pm2_5
                });

            }
            return states;
        }
    }
}
