﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AxisGroupingDemo.Data.Model
{
    public class Unit
    {
        public string Continent { get; set; }
        public string Country { get; set; }
        public string Name { get; set; }
        public double Value { get; set; }
        public static List<Unit> Data()
        {
            var data = new List<Unit>();
            var rnd = new Random();

            //America
            data.Add(new Unit { Name = "Sales", Value = rnd.Next(100, 300), Country = "US", Continent = "America" });
            data.Add(new Unit { Name = "Marketing", Value = rnd.Next(100, 300), Country = "US", Continent = "America" });
            data.Add(new Unit { Name = "Engineering", Value = rnd.Next(100, 300), Country = "US", Continent = "America" });
            data.Add(new Unit { Name = "Sales", Value = rnd.Next(100, 300), Country = "Brazil", Continent = "America" });
            data.Add(new Unit { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Brazil", Continent = "America" });
            data.Add(new Unit { Name = "Sales", Value = rnd.Next(100, 300), Country = "Canada", Continent = "America" });
            data.Add(new Unit { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Canada", Continent = "America" });


            //Asia
            data.Add(new Unit { Name = "Sales", Value = rnd.Next(100, 300), Country = "China", Continent = "Asia" });
            data.Add(new Unit { Name = "Marketing", Value = rnd.Next(100, 300), Country = "China", Continent = "Asia" });
            data.Add(new Unit { Name = "Engineering", Value = rnd.Next(100, 300), Country = "China", Continent = "Asia" });
            data.Add(new Unit { Name = "Sales", Value = rnd.Next(100, 300), Country = "Japan", Continent = "Asia" });
            data.Add(new Unit { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Japan", Continent = "Asia" });
            data.Add(new Unit { Name = "Sales", Value = rnd.Next(100, 300), Country = "India", Continent = "Asia" });
            data.Add(new Unit { Name = "Marketing", Value = rnd.Next(100, 300), Country = "India", Continent = "Asia" });
            data.Add(new Unit { Name = "Engineering", Value = rnd.Next(100, 300), Country = "India", Continent = "Asia" });

            //Europe
            data.Add(new Unit { Name = "Sales", Value = rnd.Next(100, 300), Country = "Germany", Continent = "Europe" });
            data.Add(new Unit { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Germany", Continent = "Europe" });
            data.Add(new Unit { Name = "Engineering", Value = rnd.Next(100, 300), Country = "Germany", Continent = "Europe" });
            data.Add(new Unit { Name = "Sales", Value = rnd.Next(100, 300), Country = "UK", Continent = "Europe" });
            data.Add(new Unit { Name = "Marketing", Value = rnd.Next(100, 300), Country = "UK", Continent = "Europe" });
            data.Add(new Unit { Name = "Sales", Value = rnd.Next(100, 300), Country = "France", Continent = "Europe" });
            data.Add(new Unit { Name = "Marketing", Value = rnd.Next(100, 300), Country = "France", Continent = "Europe" });
            data.Add(new Unit { Name = "Engineering", Value = rnd.Next(100, 300), Country = "France", Continent = "Europe" });

            return data;
        }
    }

    public class HierarchicalUnit
    {

        public string Continent { get; set; }
        public string Country { get; set; }
        public string Name { get; set; }

        private double _value;

        public double Value
        {
            get
            {
                if (Items != null)
                {
                    _value = Items.Sum(x => x.Value);
                }
                return _value;
            }

            set
            {
                _value = value;
            }
        }

        public List<HierarchicalUnit> Items { get; set; }

        public static List<HierarchicalUnit> Data()
        {
            var data = new List<HierarchicalUnit>();
            var rnd = new Random();

            data.Add(new HierarchicalUnit
            {
                Continent = "Americas",
                Items = new List<HierarchicalUnit>()
                {
                    new HierarchicalUnit
                    {
                        Country = "US",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                        }
                    },
                    new HierarchicalUnit
                    {
                        Country = "Mexico",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)},

                        }
                    },
                    new HierarchicalUnit
                    {
                        Country = "Colombia",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)},

                        }
                    },
                }
            });

            data.Add(new HierarchicalUnit
            {
                Continent = "Asia",
                Items = new List<HierarchicalUnit>()
                {
                    new HierarchicalUnit
                    {
                        Country = "China",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                        }
                    },
                    new HierarchicalUnit
                    {
                        Country = "Japan",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                        }
                    },
                    new HierarchicalUnit
                    {
                        Country = "India",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)}
                        }
                    },
                }
            });

            data.Add(new HierarchicalUnit
            {
                Continent = "Europe",
                Items = new List<HierarchicalUnit>()
                {
                    new HierarchicalUnit
                    {
                        Country = "Italy",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)},
                        }
                    },
                    new HierarchicalUnit
                    {
                        Country = "UK",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                        }
                    },
                    new HierarchicalUnit
                    {
                        Country = "Spain",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)}
                        }
                    },
                }
            });

            return data;
        }

        public static List<HierarchicalUnit> SingleLevelData()
        {
            var data = new List<HierarchicalUnit>();
            var rnd = new Random();

            data.AddRange(new[] {
                new HierarchicalUnit
            {
                Country = "US",
                Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)},
                        }
            },
            new HierarchicalUnit
            {
                Country = "Mexico",
                Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                        }
            },
            new HierarchicalUnit
                    {
                        Country = "Colombia",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                        }
                    },
            new HierarchicalUnit
                               {
                                   Country = "China",
                                   Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)},
                        }
                               },
            new HierarchicalUnit
                    {
                        Country = "Japan",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                        }
                    },
            new HierarchicalUnit
                    {
                        Country = "India",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)}
                        }
                    },
            new HierarchicalUnit
                      {
                          Country = "Italy",
                          Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)},
                        }
                      },
            new HierarchicalUnit
                    {
                        Country = "UK",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                        }
                    },
            new HierarchicalUnit
                    {
                        Country = "Spain",
                        Items = new List<HierarchicalUnit>()
                        {
                            new HierarchicalUnit{Name = "Sales",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Marketing",Value = rnd.Next(100,300)},
                            new HierarchicalUnit{Name = "Engineering",Value = rnd.Next(100,300)}
                        }
                    }
                    });

            return data;
        }
    }

    public class DataItem
    {
        public string Year { get; set; }
        public string Country { get; set; }
        public string Name { get; set; }
        public double Value { get; set; }

        public static List<DataItem> GetData()
        {
            var data = new List<DataItem>();
            var rnd = new Random();

            //US
            data.Add(new DataItem { Name = "Sales", Value = rnd.Next(100, 300), Country = "US", Year = "2015" });
            data.Add(new DataItem { Name = "Marketing", Value = rnd.Next(100, 300), Country = "US", Year = "2015" });
            data.Add(new DataItem { Name = "Engineering", Value = rnd.Next(100, 300), Country = "US", Year = "2015" });

            data.Add(new DataItem { Name = "Sales", Value = rnd.Next(100, 300), Country = "US", Year = "2016" });
            data.Add(new DataItem { Name = "Marketing", Value = rnd.Next(100, 300), Country = "US", Year = "2016" });
            data.Add(new DataItem { Name = "Engineering", Value = rnd.Next(100, 300), Country = "US", Year = "2016" });

            data.Add(new DataItem { Name = "Sales", Value = rnd.Next(100, 300), Country = "US", Year = "2017" });
            data.Add(new DataItem { Name = "Marketing", Value = rnd.Next(100, 300), Country = "US", Year = "2017" });
            data.Add(new DataItem { Name = "Engineering", Value = rnd.Next(100, 300), Country = "US", Year = "2017" });

            //Brazil
            data.Add(new DataItem { Name = "Sales", Value = rnd.Next(100, 300), Country = "Brazil", Year = "2015" });
            data.Add(new DataItem { Name = "Sales", Value = rnd.Next(100, 300), Country = "Brazil", Year = "2016" });
            data.Add(new DataItem { Name = "Sales", Value = rnd.Next(100, 300), Country = "Brazil", Year = "2017" });

            data.Add(new DataItem { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Brazil", Year = "2015" });
            data.Add(new DataItem { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Brazil", Year = "2016" });
            data.Add(new DataItem { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Brazil", Year = "2017" });


            //Canada
            data.Add(new DataItem { Name = "Sales", Value = rnd.Next(100, 300), Country = "Canada", Year = "2015" });
            data.Add(new DataItem { Name = "Sales", Value = rnd.Next(100, 300), Country = "Canada", Year = "2016" });
            data.Add(new DataItem { Name = "Sales", Value = rnd.Next(100, 300), Country = "Canada", Year = "2017" });

            data.Add(new DataItem { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Canada", Year = "2015" });
            data.Add(new DataItem { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Canada", Year = "2016" });
            data.Add(new DataItem { Name = "Marketing", Value = rnd.Next(100, 300), Country = "Canada", Year = "2017" });

            data.Add(new DataItem { Name = "Engineering", Value = rnd.Next(100, 300), Country = "Canada", Year = "2015" });
            data.Add(new DataItem { Name = "Engineering", Value = rnd.Next(100, 300), Country = "Canada", Year = "2016" });
            data.Add(new DataItem { Name = "Engineering", Value = rnd.Next(100, 300), Country = "Canada", Year = "2017" });

            return data;

        }
    }
}
