﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.Chart;
using AxisGroupingDemo.Data.Model;

namespace AxisGroupingDemo.Samples
{
    public partial class SwitchGroupsDemo : UserControl
    {
        private FlexChart flexChart1;
        private ComboBox cbGroupBy;
        private Axis categoryAxis;

        public SwitchGroupsDemo()
        {
            InitializeComponent();
            InitializeControls();
            SetupChart();
            cbGroupBy.SelectedValue = "Year,Country";
        }

        private void SetupChart()
        {
            flexChart1.Series.Clear();
            flexChart1.BindingX = "Name";
            flexChart1.Header.Content = "Employee Distribution By Region and Year";
            flexChart1.Header.Style.Font = new System.Drawing.Font(flexChart1.Font.FontFamily, 14);

            flexChart1.AxisX.LabelAngle = 90;
            flexChart1.Series.Add(new C1.Win.Chart.Series
            {
                Binding = "Value"
            });
          
            flexChart1.DataSource = DataItem.GetData(); 
            categoryAxis = flexChart1.AxisX;
            categoryAxis.GroupSeparator = C1.Chart.AxisGroupSeparator.Grid;
        }

        private void InitializeControls()
        {
            baseSample1.lblTitle.Text = Properties.Resources.SwitchGroupsTitle; ;
            baseSample1.tbDescription.Text = Properties.Resources.SwitchGroupsDesc; ;

            flexChart1 = baseSample1.flexChart1;

            cbGroupBy = new ComboBox()
            {
                FormattingEnabled = true,
                ForeColor = Color.Gray,
                FlatStyle = FlatStyle.Flat,
                Width = 200
            };
            cbGroupBy.DataSource = new string[] { "Year,Country", "Country,Year" };

            cbGroupBy.Format += (s, e) => e.Value = string.Format("Group By: {0}", e.Value);
            cbGroupBy.SelectedValueChanged += (s, e) =>
            {
                categoryAxis.GroupNames = cbGroupBy.SelectedValue.ToString();
                flexChart1.Rebind();
            };

            baseSample1.pControls.Controls.Add(cbGroupBy);
        }
    }
}
